;       Keyboard routines for Microsoft FORTRAN v. 3.30
;
;    KEYHIT(0) is a LOGICAL FUNCTION with a dummy argument.
;      = .TRUE. if a character is ready from the keyboard
;      = .FALSE. if no key has been hit
;
;    GETC(0) is an INTEGER FUNCTION with a dummy argument.
;      The low byte has the normal ASCII character.
;      If the low byte is zero, we have a special character
;      (function or alt keys) and the high byte has the scan code.
;
;    Both KEYHIT and GETC use the BIOS keyboard interupt, 16h.
;
DATA    SEGMENT PUBLIC 'DATA'     ; This header garbage was copied
DATA    ENDS                      ; from the Microsoft FORTRAN manual.
DGROUP  GROUP DATA
CODE    SEGMENT 'CODE'
        ASSUME CS:CODE,DS:DGROUP,SS:DGROUP
        PUBLIC KEYHIT,GETC
;
KEYHIT  PROC    FAR
        PUSH    BP      ; FORTRAN needs BP and DS saved. The BIOS saves DS.
        MOV     AH,1    ; service 1, report if a character is ready
        INT     16H     ; BIOS keyboard interupt
        MOV     AX,0    ; assume result is FALSE
        JZ      REPORT  ; character is not ready if zero flag is set
        MOV     AL,1    ; result is TRUE, character is ready
REPORT: POP     BP
        RET     04H
        KEYHIT  ENDP
;
GETC    PROC    FAR
        PUSH    BP
        MOV     AX,0    ; service 0, get a character
        INT     16H     ; The character is returned in AX, just
        POP     BP      ; like a FORTRAN function, which is handy.
        RET     04H
        GETC    ENDP
;
        CODE    ENDS
END

